<template>
    <div
        class="user-role w-full pb-[65px]"
    >
        <div
            v-if="withBackHeader"
            class="flex justify-start text-xl space-x-4 py-6 px-4 capitalize"
            :class="{
                'text-white': isDarkPage,
            }"
        >
            <div
                class="cursor-pointer"
                @click="$router.go(-1)"
            >
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="lg"
                />
            </div>
            <div>
                <template
                    v-if="$route.meta.title"
                >
                    {{ $t($route.meta.title) }}
                </template>
            </div>
        </div>
        <router-view v-slot="{ Component }">
            <transition name="page-slide" mode="out-in">
                <component :is="Component" />
            </transition>
        </router-view>
        <bottom-navigation />
    </div>
</template>
<script setup>
import BottomNavigation from "~/layouts/bottom-navigation.vue";
import EventBus from "!/event-bus.js";
import {onUnmounted, computed, onMounted} from "vue";
import {useRoute} from "vue-router";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";

const $route = useRoute();
EventBus.on('BACKGROUND_LIGHT', () => {
    document.body.classList.remove('bg-dark');
});
EventBus.on('BACKGROUND_DARK', () => {
    document.body.classList.add('bg-dark');
});

onUnmounted(() => {
    EventBus.off('BACKGROUND_DARK');
    EventBus.off('BACKGROUND_LIGHT');
});
const withBackHeader = computed(() => {
    return $route.meta.back;
});
const isDarkPage = computed(() => {
    return $route.meta.dark;
});

onMounted(() => {
    if ($route.meta.dark) {
        EventBus.emit('BACKGROUND_DARK');
    }
})
</script>


<style scoped>
.page-slide-enter-active,
.page-slide-leave-active {
    transition: 400ms ease all;
}
.page-slide-enter-from,
.page-slide-leave-to {
    opacity: 0;
    transform: translateY(60px);
}
</style>
